function [Rcum] = Func_GenCum(rf, Rs)
R = Rs+rf;
T = length(R);
R1x = Rs;
R2x = R(1:T-1).*R(2:T) - rf(1:T-1).*rf(2:T);
R2x = [nan; R2x]/2;
      
R3x = R(1:T-2).*R(2:T-1).*R(3:T) - rf(1:T-2).*rf(2:T-1).*rf(3:T); 
R3x = [nan(2,1); R3x]/3;
      
R4x = R(1:T-3).*R(2:T-2).*R(3:T-1).*R(4:T) - rf(1:T-3).*rf(2:T-2).*rf(3:T-1).*rf(4:T); 
R4x = [nan(3,1); R4x]/4;
      
R5x = R(1:T-4).*R(2:T-3).*R(3:T-2).*R(4:T-1).*R(5:T) -...
           rf(1:T-4).*rf(2:T-3).*rf(3:T-2).*rf(4:T-1).*rf(5:T);
R5x = [nan(4,1); R5x]/5; 
      
R6x = R(1:T-5).*R(2:T-4).*R(3:T-3).*R(4:T-2).*R(5:T-1).*R(6:T) -...
           rf(1:T-5).*rf(2:T-4).*rf(3:T-3).*rf(4:T-2).*rf(5:T-1).*rf(6:T);
R6x = [nan(5,1); R6x]/6; 
      
R7x = R(1:T-6).*R(2:T-5).*R(3:T-4).*R(4:T-3).*R(5:T-2).*R(6:T-1).*...
           R(7:T) -rf(1:T-6).*rf(2:T-5).*rf(3:T-4).*rf(4:T-3).*rf(5:T-2).*...
           rf(6:T-1).*rf(7:T);
R7x = [nan(6,1); R7x]/7; 
      
R8x = R(1:T-7).*R(2:T-6).*R(3:T-5).*R(4:T-4).*R(5:T-3).*R(6:T-2).*...
           R(7:T-1).*R(8:T) -rf(1:T-7).*rf(2:T-6).*rf(3:T-5).*rf(4:T-4).*...
           rf(5:T-3).*rf(6:T-2).*rf(7:T-1).*rf(8:T);
R8x = [nan(7,1); R8x]/8; 
      
R9x = R(1:T-8).*R(2:T-7).*R(3:T-6).*R(4:T-5).*R(5:T-4).*R(6:T-3).*...
           R(7:T-2).*R(8:T-1).*R(9:T) -rf(1:T-8).*rf(2:T-7).*rf(3:T-6).*rf(4:T-5).*...
           rf(5:T-4).*rf(6:T-3).*rf(7:T-2).*rf(8:T-1).*rf(9:T);
R9x = [nan(8,1); R9x]/9; 
      
R10 = R(1:T-9).*R(2:T-8).*R(3:T-7).*R(4:T-6).*R(5:T-5).*R(6:T-4).*...
           R(7:T-3).*R(8:T-2).*R(9:T-1).*R(10:T);
Rf10 = rf(1:T-9).*rf(2:T-8).*rf(3:T-7).*rf(4:T-6).*rf(5:T-5).*rf(6:T-4).*...
             rf(7:T-3).*rf(8:T-2).*rf(9:T-1).*rf(10:T);
R10x = [nan(9,1); R10-Rf10]/10; 
      
R11 = R(1:T-10).*R(2:T-9).*R(3:T-8).*R(4:T-7).*R(5:T-6).*R(6:T-5).*...
            R(7:T-4).*R(8:T-3).*R(9:T-2).*R(10:T-1).*R(11:T);
Rf11 = rf(1:T-10).*rf(2:T-9).*rf(3:T-8).*rf(4:T-7).*rf(5:T-6).*rf(6:T-5).*...
             rf(7:T-4).*rf(8:T-3).*rf(9:T-2).*rf(10:T-1).*rf(11:T);
R11x = [nan(10,1); R11-Rf11]/11; 
      
R12 = R(1:T-11).*R(2:T-10).*R(3:T-9).*R(4:T-8).*R(5:T-7).*R(6:T-6).*...
            R(7:T-5).*R(8:T-4).*R(9:T-3).*R(10:T-2).*R(11:T-1).*R(12:T);
Rf12 = rf(1:T-11).*rf(2:T-10).*rf(3:T-9).*rf(4:T-8).*rf(5:T-7).*rf(6:T-6).*...
             rf(7:T-5).*rf(8:T-4).*rf(9:T-3).*rf(10:T-2).*rf(11:T-1).*rf(12:T);
R12x = [nan(11,1); R12-Rf12]/12;
Rcum = [R1x, R2x, R3x, R4x, R5x, R6x, R7x, R8x, R9x, R10x, R11x, R12x];

end